#!/bin/python

import os, os.path, shutil, struct
import glob
import sys

if len(sys.argv) !=2:
	print 'need to specify the path to the persist files; i.e. %s /opt/gpudb/persist'%(sys.argv[0])
	sys.exit()

fdir = sys.argv[1]

orig_ver = os.path.join(fdir,"version")
bkup_ver = orig_ver+'.bkup'

fin = open(orig_ver,"r")
persist_version = fin.read()
fin.close()

source_persist_version = '2015012420'

if (persist_version != source_persist_version):
	print 'this script only modifies files from persistence version: %s; the current persist version in: %s is %s'%(source_persist_version,fdir,persist_version)
	sys.exit()

shutil.move(orig_ver,bkup_ver)

#need to match rank11-tom42
files_converted = 0
all_dirs = glob.glob(os.path.join(fdir,'rank*[0-9]-tom*[0-9]'))

for d in all_dirs:
	print d

	for f in os.listdir(d):
		if '[_GAIA_ID]' in f:
			print f

			orig_file = os.path.join(d,f)
			print orig_file
			bkup_file = orig_file+'.bkup'
			

			#read the orig file
			fin = open(orig_file,"rb")
			data = fin.read();
			fin.close()
			#print len(data)
			#print data

			#print struct.unpack('Q',data[0:8])
			#print struct.unpack('i',data[8:12])
			#print struct.unpack('Q',data[12:20])

			new_hdr1 = struct.pack('Q',8)	#8-bytes per element
			new_hdr2 = struct.pack('i',64)	#0x40 is code for int64_t data
			new_hdr3 = data[12:20]

			new_hdr = new_hdr1+new_hdr2+new_hdr3

			shutil.move(orig_file,bkup_file)

			fout = open(orig_file,"wb")
			fout.write(new_hdr)
			for x in range(20,len(data),16):
				fout.write(data[x+8:x+16])
			fout.close()
			files_converted += 1

print 'converted: %d files'%(files_converted)


fout = open(orig_ver,"w")
fout.write("2015021000")
fout.close()

print 'done'